import React, { useState, useEffect } from 'react';
import http from "http";
import https from "https";
import express from "express";
import { Server } from "socket.io";
import fetch from 'node-fetch';


var app = express();
const server = http.createServer(app);

const socketIo = new Server(server, {
    cors: {
        origin: "*",
    }
});

socketIo.on("connection", async (socket) => { ///Handle khi có connect từ client tới
    console.log("New client connected: " + socket.id);
    
    socket.on("sendDataClient", async function (data) { // Handle khi có sự kiện tên là sendDataClient từ phía client
        console.log("New client connected");
        const receiveData = "Server receive: " + data;
        //console.log("Msg: " + data.timestamp)
        //Thêm message vào database
        //console.log(receiveData);
        const data_send = {
            content: data.content,
            id: data.id,
            name: data.name,
            artist_id: data.artist_id,
            artist_name: data.artist_name,
            chat_user: data.chat_user,
            event_type: data.event_type,
            event_id: data.event_id,
        };
        //NO
        const formAddNewMessage = new URLSearchParams();
        formAddNewMessage.append('message', data.content);
        formAddNewMessage.append('user_id', data.id);
        formAddNewMessage.append('user_name', data.name);
        formAddNewMessage.append('artist_id', data.artist_id);
        formAddNewMessage.append('artist_name', data.artist_name);
        formAddNewMessage.append('chat_user_type', data.chat_user);
        formAddNewMessage.append('event_type', data.event_type);
        formAddNewMessage.append('event_id', data.event_id);
        console.log("Start update new chat...");
        const chat  =  await await fetch("https://api.connect-ink.com/API/TATU/API/chat/new_messages2.php",
            {
                method: 'POST',
                headers: {
                    'Content-Type': "application/x-www-form-urlencoded;charset=UTF-8",
                    'Authorization': 'Basic ' + btoa('tatu:fYg5FRbQ')
                },
                body: formAddNewMessage.toString()
            }
        );
        //const res = await chat.json();
        //console.log(chat);
        //Sau khi add data
        /*const data_send = {
            content: data.content,
            id: data.id,
            name: data.name,
            artist_id: data.artist_id,
            artist_name: data.artist_name,
            chat_user: data.chat_user,
            event_type: data.event_type,
            event_id: data.event_id
        };*/
        socketIo.emit("sendDataServer", { data_send });// phát sự kiện  có tên sendDataServer cùng với dữ liệu tin nhắn từ phía server
    });
    //Su kien stream order
    socket.on("sendStreamOrder", async function (data) {
        const data_send = {
            select: data.select,
            artist_id: data.artist_id,
            user_id: data.user_id,
            schedule: data.schedule,
            id: data.id,
            deposit: data.deposit,
            part_body: data.part_body,
            tattoo_id: data.tattoo_id,
            tattoo_name: data.tattoo_name,
            tattoo_type: data.tattoo_type,
            price: data.price,
        };
        socketIo.emit("receiveStreamOrder", { data_send });
    });
    //Su kien stream connect ink
    socket.on("sendStreamClientConnectInk", async function () {
        console.log("Add new client connect ink");
        socketIo.emit("receiveStreamClientConnectInk");
    });
        //Su kien stream connect ink
        socket.on("sendStreamArtistConnectInk", async function () {
            console.log("Add new artist connect ink");
            socketIo.emit("receiveStreamArtistConnectInk");
        });
    //Su kien strem ask price
    socket.on("sendStreamAskPrice", async function (data) {
        const data_send = {
            select: data.select,
            artist_id: data.artist_id,
            user_id: data.user_id,
            ask_price_id: data.ask_price_id,
            price: data.price,
        };
        socketIo.emit("receiveStreamAskPrice", { data_send });
    });
    //Su kien push nitification
    socket.on("sendStreamNotification", async function (data) {
        const formAddNewNotification = new URLSearchParams();
        formAddNewNotification.append('user_type', data.user_type);
        formAddNewNotification.append('user_id', data.user_id);
        formAddNewNotification.append('artist_id', data.artist_id);
        formAddNewNotification.append('notification_title', data.notification_title);
        formAddNewNotification.append('notification_content', data.notification_content);
        formAddNewNotification.append('notification_type', data.notification_type);
        formAddNewNotification.append('event_id', data.event_id);
        console.log("Start update new Notification...");
        const notification  = await await fetch("https://api.connect-ink.com/API/TATU/API/notification/notification_push_info.php",
            {
                method: 'POST',
                headers: {
                    'Content-Type': "application/x-www-form-urlencoded;charset=UTF-8",
                    'Authorization': 'Basic ' + btoa('tatu:fYg5FRbQ')
                },
                body: formAddNewNotification.toString()
            }
        );
        const data_send = {
            select: data.select,
            notification_title: data.notification_title,
            notification_content: data.notification_content,
            notification_type: data.notification_type,
            event_id: data.event_id,
            artist_id: data.artist_id,
            user_id: data.user_id,
            user_type:data.user_type
        };
        socketIo.emit("receiveStreamNotification", { data_send });
    });
    
        socket.on("sendDataManualFromApp", async function (data) { // Handle khi có sự kiện tên là sendDataManualFromApp từ phía client
        console.log("Robot send: " + data.emei);
        // if(data.emei != ""){
        //     const emei = data.emei;
        //     const user_id = data.user_id;
        //     const code = data.code;
        //     const receiver = data.receiver;
        //     const other = 1;
        // }else{
        //     emei = "unknow";
        //     user_id = "unknow";
        //     code = "unknow";
        //     receiver = "unknow";
        //     other = 0;
        // }
        
        const data_send = {
            emei: data.emei,
            user_id: data.user_id,
            code: data.code,
            receiver: data.receiver,
        };

        
        await fetch("https://api.connect-ink.com/API/TATU/API/AUTH/device/Device.php",
            {
                method: 'POST',
                  headers: {
                "Content-Type": "application/json",
                Accept: "application/json",
            },
                body: JSON.stringify({ emei: data.emei, user_id: data.user_id, code: data.code, receiver: data.receiver, other: 1  })
            }
        );
        socketIo.emit("sendDataManualToDevice", { data_send });// phát sự kiện  có tên sendDataServer cùng với dữ liệu tin nhắn từ phía server
    });
    
    socket.on("sendCheckLoginError", async function (data) {
        const data_send = {
            error: data.error,
        };
        socketIo.emit("receiveCheckLoginError", { data_send });
    });
    socket.on("disconnect", () => {
        console.log("Client disconnected"); // Khi client disconnect thì log ra terminal.
    });

});

server.listen(27271, () => {
    //console.log('Server đang chay tren port 27271');
});
