import React, { useState, useEffect, useRef } from "react";
import socketIOClient from "socket.io-client";

//const host = "http://admin.elevate-mobility.com:27271";
const host = "http://hydra-cyborg.com:27271";
function App() {
  const [mess, setMess] = useState([]);
  const [message, setMessage] = useState('');
  const [id, setId] = useState();

  const socketRef = useRef();
  const messagesEnd = useRef();

  useEffect(() => {
    socketRef.current = socketIOClient.connect(host)
    socketRef.current.on('getId', data_send => {
      setId(data_send)
    })
    //socketRef.current.on('receiveStreamOrder', dataGot => {
    //  setMess(oldMsgs => [...oldMsgs, dataGot.data_send ])
    //})
    socketRef.current.on('receiveStreamOrder', dataGot => {
      setMess(oldMsgs => [...oldMsgs, dataGot.data_send ])
    })
    return () => {
      socketRef.current.disconnect();
    };
  }, []);
  const sendMessage = () => {
    /*var msg_date = new Date().toLocaleString("en-GB", {timeZone: "Asia/Jakarta"});
    var msg_date_arr  = msg_date.split(",");
        var msg_datetime =  msg_date_arr[0] + msg_date_arr[1];*/
    if (message !== null) {
      const msg = {
        select: message,
        artist_id:"ART0000001",
        user_id:"a0000002",
        id: "OD0000059",
        schedule: "2022-05-28",
        deposit: "15",
        part_body: "Head",
        tattoo_id: "",
        tattoo_name: "Diamond",
        tattoo_type: "Mini_tattoo",
        price: 100,
      }
      socketRef.current.emit('sendStreamOrder', msg)
      /*Khi emit('sendDataClient') bên phía server sẽ nhận được sự kiện có tên 'sendDataClient' và handle như câu lệnh trong file index.js
            socket.on("sendDataClient", function(data) { // Handle khi có sự kiện tên là sendDataClient từ phía client
              socketIo.emit("sendDataServer", { data });// phát sự kiện  có tên sendDataServer cùng với dữ liệu tin nhắn từ phía server
            })
      */
      setMessage('')
    }
  }

  const renderMess = mess.map((m, index) =>
    <div
      key={index}
      className={`${m.id === id ? 'your-message' : 'other-people'} chat-item`}
    >
      {"SELECT: " + m.select + " Artist id: " + m.artist_id + "  CLIENT: " + m.user_id + " ORDER " + m.id + " DATE: " + m.schedule + " DEPOSITE " + m.deposit + " PART " + m.part_body + " TATU ID " + m.tattoo_id + " TATU NAME " + m.tattoo_name + " TYPE " + m.tattoo_type + " PRICE " + m.price}
      {/*"Error: " + m.error*/}
    </div>
  )


  const onEnterPress = (e) => {
    if (e.keyCode === 13 && e.shiftKey === false) {
      sendMessage()
    }
  }

  const handleChange = (e) => {
    setMessage(e.target.value)
  }

  return (
      <div className="box-chat">
        <div className="box-chat_message">
          {renderMess}

          <div style={{ float: "left", clear: "both" }}
            ref={messagesEnd}>
          </div>
        </div>

        <div className="send-box">
          <textarea
            value={message}
            onKeyDown={onEnterPress}
            onChange={handleChange}
            placeholder="Nhập tin nhắn ..."
          />
          <button onClick={sendMessage}>
            Send
          </button>
        </div>
      </div>
  );
}

export default App;